#ifndef CHECKREACH_H_INCLUDED
#define CHECKREACH_H_INCLUDED

#include "board.h"
#include "game.h"
#include "irensei_rule_description.h"
#include "irensei_ai_descripter.h"	// for struct IRENSEI_DEBUG_BOARD

namespace Irensei {

/*
n AőłVAɂȂꏊBԒA͍lȂ
ɂāA
EBUɂȂƂ 1
ETɂȂƂ 2
EUɂȂƂ -1
Eǂ̕ɕׂĂVłȂƂ -128
B
SׂāAłl̏̂(Βl΂炾AΒlȂ琳̐)B
ǂɂVɂȂ\̖Ƃ -128
*/
void CheckReach(
	IRENSEI_DEBUG_BOARD & rtbl, 			// [out]reach table
	const Board * board, 
	const IRENSEI_RULE_DESCRIPTION & rule,	// ՊO𓾂邽߂ outerInvalidLines g
	Game::EBlackOrWhite order 				// ̐΂̐F𓾂邽߂Ɏg
);


// CheckReach ́AdlႤo[W
// [`̉ӏ 0Ã[`Ɋ֌W΂̉ӏ orderB̑ -128
void Check0Reach(
	IRENSEI_DEBUG_BOARD & rtbl, 			// [out]reach table
	const Board * board, 
	const IRENSEI_RULE_DESCRIPTION & rule,	// lineLnegth, outerInvalidLines
	Game::EBlackOrWhite order
);


}	// namespace Irensei

#endif
