/*
͘AŌuAv\B
͘AvOł́AuAvł͂ȂuсvƂB
An AAAȂǂ̎Ⴆ邱Ƃ̂Ȃ̂͂̂܂܎gpB
c΂߂ɕ񂾂̂ StraightB
т̗[ end ƌĂԁB
end ̐ stop ƌĂԁB
͏c̕тłB
{		first stop
		first end


		last end
{		last stop
stop ́A_ՊOȊO̐F̐΂łB

String ͈͌Iȃf[^AStraight ͈͘AL̃[ɊւB
*/

#ifndef STRAIGHTDATA_H_INCLUDED
#define STRAIGHTDATA_H_INCLUDED

#include "board.h"
#include <set>


namespace Irensei {


struct StraightData
{
	StraightData()										{};
	explicit StraightData( const Board * board )		{ Remake( board ); };

	void Remake( const Board * board );

	struct delta {
		delta operator * ( const int m ) const	{ delta r; r.x = x*m; r.y = y*m; return r; }
		delta & operator *= ( const int m )		{ x *= m; y *= m; return *this; }
		delta rot( void ) const/*XOx*/	{ delta r; r.x = y; r.y = -x; return r; }
		int x;
		int y;
	};
	struct Position {
//		Position( int a, int b ) : x(a), y(b)	{}
		bool operator < ( const Position & o ) const		{ return x < o.x || (x == o.x && y < o.y); }
		bool operator == ( const Position & o ) const		{ return x == o.x && y == o.y; }
		Position operator + ( const delta & d ) const		{ Position r; r.x = x+d.x; r.y = y+d.y; return r; }
		Position & operator += ( const delta & d )			{ x += d.x; y += d.y; return *this; }
		Position operator - ( const delta & d ) const		{ Position r; r.x = x-d.x; r.y = y-d.y; return r; }
		Position & operator -= ( const delta & d )			{ x -= d.x; y -= d.y; return *this; }
		bool isOuterOf( int outer/* line count*/ ) const {
			return x < outer || x >= Board::MaxX - outer || y < outer || y >= Board::MaxY - outer;
		}
		int x;
		int y;
	};
	enum EDirection {
		EDirNone,
		EDirFirst,
		EDirHolizontal = EDirFirst,
		EDirVertical,
		EDirRUp,
		EDirRDown,
		EDirLDown = EDirRUp,
		EDirLUp = EDirRDown,
		EDirLast
	};
	struct Straight {
		Straight();
		Straight( const Straight & o );
		int idx;
		Board::EStone color;
		EDirection dir;
		int length;
		union /* end */{		// n_ƏI_Bn_͍܂͏
			Position ends[2];
			struct {
				Position firstend;
				Position lastend;
			};
			struct /*named end*/ {
				union {
					Position left;
					Position top;
					Position lefttop;
					Position leftdown;
				};
				union {
					Position right;
					Position down;
					Position rightdown;
					Position rightup;
				};
			};
		};
		union /*stop*/{		// nOƏIOBn_͍܂͏
			Board::EStone stops[2];
			struct {
				Board::EStone firststop;
				Board::EStone laststop;
			};
		};
		const Position * outer;		// O̐
		int outdist;				// P܂ł̋iPɂƂ 0 j
		bool operator < ( const Straight & o ) const {	// std::set<> Ŏg߂ɂ
			// A̒̂ɗ邪AȂΎn_̐΂̈ʒu
			if ( length != o.length )
				return length > o.length;
			if ( dir != o.dir )
				return dir < o.dir;
			else
				return firstend < o.firstend || (firstend == o.firstend && lastend < o.lastend ); 
		}
		Position firstStopPosition( void ) const	{ return firstend - GetDelta(dir); }
		Position lastStopPosition( void ) const		{ return lastend + GetDelta(dir); }
	};

	std::set< Straight > straights;		// ɓĂ

	// ̈ʒuւ̘AԂ܂B
	// _^ƘA_Ԃ܂
	static int MakeStraight( Straight & straight, const Board * board, int x, int y, EDirection dir );

	static delta GetDelta( EDirection dir );
private:
};



} /* namespace Irensei */

#endif
