/*
͌ŌƂ́uAv\B
*/

#ifndef STRINGDATA_H_INCLUDED
#define STRINGDATA_H_INCLUDED

#include <vector>
#include <set>
#include "board.h"

namespace Irensei {


struct StringData
{
	StringData();
	explicit StringData( const Board * board );
	StringData( const StringData & o ) : strings(o.strings)		{ memcpy( pos2stringTable, o.pos2stringTable, sizeof(pos2stringTable) ); };

	void Remake( const Board * board );

	struct Position {
		Position( int a, int b ) : x(a), y(b)	{}
		bool operator < ( const Position & o ) const		{ return x < o.x || (x == o.x && y < o.y); }
		bool operator == ( const Position & o ) const		{ return x == o.x && y == o.y; }
		int x;
		int y;
	};
	struct String {
		int idx;
		Board::EStone color;
		std::set< Position > breathPoints;	// ċz_
		std::set< Position > stones;
	};

	static void MakeString( 
		String & string, 										// óBA
		int pos2stringTable[ Board::MaxY ][ Board::MaxX ], 		// óBς݂̉ӏB -1 Ŗ߂Ă
		const Board * board, int x, int y
	);

	bool CheckSityou( int x, int y, Board::EStone side ) const;

	int pos2stringTable[ Board::MaxY ][ Board::MaxX ];
	std::vector< String > strings;
};



}	// namespace Irensei


#endif
