/*
uсv̓r󂢂ĂuAv\B
{		first stop
		first end

{		space
		last end
{		last stop
end  stop ͂QAspace ͂Oȏ̏WŎB
L̗͈ASłB

uAv́uсv܂ށB
{{{{{{{{{{̂悤Ȃ̂F߂Ȃ߂ɁAA𐧌p[^KvłB
*/


#ifndef VIRTUALSTRAIGHT_H_INCLUDED
#define VIRTUALSTRAIGHT_H_INCLUDED

#include "board.h"
#include "StraightData.h"
#include <vector>
#include <set>


namespace Irensei {


struct VirtualStraightData
{
	typedef StraightData::delta delta;
	typedef StraightData::Position Position;

	VirtualStraightData()									{};
	explicit VirtualStraightData( const Board * board, int limitlen )		{ Remake( board, limitlen ); };

	void Remake( const Board * board, int limitlen/*A܂Ő邩*/ );

	enum EDirection {
		EDirNone,
		EDirFirst,
		EDirHolizontal = EDirFirst,
		EDirVertical,
		EDirRUp,
		EDirRDown,
		EDirLDown = EDirRUp,
		EDirLUp = EDirRDown,
		EDirLast
	};
	struct VirtualStraight {
		VirtualStraight();
		VirtualStraight( const VirtualStraight & o );
		int idx;
		Board::EStone color;
		EDirection dir;
		int length;				// [̒
		int cntStones;			// A\΂̐
		std::vector< Position > spaces;		// A̒ɂ_
		union /* end */{		// n_ƏI_Bn_͍܂͏
			Position ends[2];
			struct {
				Position firstend;
				Position lastend;
			};
			struct /*named end*/ {
				union {
					Position left;
					Position top;
					Position lefttop;
					Position leftdown;
				};
				union {
					Position right;
					Position down;
					Position rightdown;
					Position rightup;
				};
			};
		};
		union /*stop*/{		// nOƏIOBn_͍܂͏
			Board::EStone stops[2];
			struct {
				Board::EStone firststop;
				Board::EStone laststop;
			};
		};
		const Position * inner;		// ̐
		const Position * outer;		// O̐
		int outdist;				// P܂ł̋iPɂƂ 0 j
		bool operator < ( const VirtualStraight & o ) const {	// std::set<> Ŏg߂ɂ
			// A̒́Aΐ̂ɗ邪AȂΎn_̐΂̈ʒu
			if ( length != o.length )
				return length > o.length;
			if ( cntStones != o.cntStones )
				return cntStones > o.cntStones;
			if ( dir != o.dir )
				return dir < o.dir;
			else
				return firstend < o.firstend || (firstend == o.firstend && lastend < o.lastend ); 
		}
		Position firstStopPosition( void ) const	{ return firstend - GetDelta(dir); }
		Position lastStopPosition( void ) const		{ return lastend + GetDelta(dir); }
	};

	// ̈ʒuւ̈AԂ܂B
	static int MakeVirtualStraight( VirtualStraight & straight, const Board * board, int x, int y, EDirection dir, int limitlen );

	static delta GetDelta( EDirection dir )	{ return StraightData::GetDelta( static_cast<StraightData::EDirection>(dir) ); }

	std::set< VirtualStraight > vstraights;		// ɓĂ
};


}

#endif
